﻿$NetworkDIR = "\\nx1\1c\"
$TempDIR = "c:\temp"
Remove-Item -Path (join-path $NetworkDIR "*.dbf") -Exclude "emptybank.dbf"
set-location $TempDIR
New-Item -Path $TempDIR -ItemType Directory -ErrorAction SilentlyContinue
$OBDPath = join-path $NetworkDIR "sbrf.obd"
$TempOBD = join-path $TempDIR ([IO.Path]::GetRandomFilename())
$TempOBD = [System.IO.Path]::ChangeExtension($TempOBD,'obd')
Copy-Item -Path $OBDPath -Destination $TempOBD
$DDF_Path = join-path $NetworkDIR "VIBOR.DDF"
$TempDDF = join-path $TempDIR ([IO.Path]::GetRandomFilename())
$TempDDF = [System.IO.Path]::ChangeExtension($TempDDF,'ddf')
Copy-Item -Path $DDF_Path -Destination $TempDDF
$DBFPath =join-path $NetworkDIR "emptybank.dbf"
$TempDBF = join-path $TempDIR ([IO.Path]::GetRandomFilename())
$TempDBF = [System.IO.Path]::ChangeExtension($TempDBF,'dbf')
Copy-Item -Path $DBFPath -Destination $TempDBF
$TempFN  = [System.IO.Path]::GetFileName($TempDBF)
Invoke-Expression "$NetworkDIR\Replace-FileString.ps1 -Pattern '%SourceFile%'  -Replacement $TempDDF -Path $TempOBD -Overwrite -Codepage 866"
Invoke-Expression "$NetworkDIR\Replace-FileString.ps1 -Pattern '%DestinationFile%'  -Replacement $TempDBF -Path $TempOBD -Overwrite -Codepage 866"
$TempEXE = join-path $TempDIR ([IO.Path]::GetRandomFilename())
$TempEXE = [System.IO.Path]::ChangeExtension($TempEXE,'exe')
Copy-Item -Path (join-path $NetworkDIR 'CONVERT.EXE') -Destination $TempEXE
$TempEXE = $TempEXE +' '+$TempOBD
$cmd = join-path $TempDIR 'run.cmd'
$SW = [IO.File]::CreateText($cmd)
Start-Sleep -Milliseconds 100 #Иначе старый добрый дос софт не видел только что созданного пустого dbf файла
$SW.WriteLine("cd "+$TempDIR)
$SW.WriteLine($TempEXE)
$SW.Flush()
$SW.Close()
Invoke-Item $cmd # Тоже корявка, почему то не получилось запустить экзешник с параметром, но по идее должен работать Invoke-Expression
Start-Sleep -Milliseconds 3000 #приложение вызывается асинхронно, нужен таймаут, чтоб дождаться его завершения. На больших объемах выписок, возможно, придётся увеличить задержку. Если есть способы синхронизации - обратная связь приветствуется. 
Copy-Item -Path $TempDBF -Destination (join-path $NetworkDIR $TempFN)
$SW = [IO.File]::CreateText((join-path $NetworkDIR 'dbflocation.txt'))
$SW.WriteLine($TempFN)
$SW.WriteLine($NetworkDIR)
$SW.Flush()
$SW.Close()
Remove-Item (join-path $TempDIR "*")